ALTER SESSION SET plsql_warnings = 'enable:all'
/

CREATE OR REPLACE PACKAGE pkg
   AUTHID DEFINER
AS
   PRAGMA DEPRECATE(pkg);

   PROCEDURE proc;
   FUNCTION func RETURN NUMBER;
END;
/

CREATE OR REPLACE PACKAGE BODY pkg
AS
   PROCEDURE proc
   IS
   BEGIN
      DBMS_OUTPUT.put_line ('old stuff');
   END;

   FUNCTION func
      RETURN NUMBER
   IS
   BEGIN
      RETURN 1;
   END;
END;
/

CREATE OR REPLACE PROCEDURE use_deprecated AUTHID DEFINER
IS
BEGIN
   pkg.proc;
END;
/

/*
PLW-06020: reference to a deprecated entity: PKG declared in unit PKG
*/

/* Make deprecation warnings errors */

ALTER SESSION SET plsql_warnings='ERROR:(6019,6020,6021,6022)'
/

ALTER PACKAGE pkg COMPILE
/

/*
PLS-06020: reference to a deprecated entity: PKG declared in unit PKG
*/

CREATE OR REPLACE PACKAGE pkg
   AUTHID DEFINER
AS
   PROCEDURE proc;

   PRAGMA DEPRECATE (proc, 'pkg.proc deprecated. Use pkg.new_proc instead.');

   PROCEDURE new_proc;
 END;
/

/* 
Whooops Don't want 6019 as an error. That just points out that you
used the pragma
*/

ALTER SESSION SET plsql_warnings='ERROR:(6020,6021,6022)'
/

CREATE OR REPLACE PACKAGE pkg
   AUTHID DEFINER
AS
   PROCEDURE proc;

   PRAGMA DEPRECATE (proc, 'pkg.proc deprecated. Use pkg.new_proc instead.');

   PROCEDURE new_proc;
 END;
/

CREATE OR REPLACE PACKAGE BODY pkg
AS
   PROCEDURE proc
   IS
   BEGIN
      DBMS_OUTPUT.put_line ('old stuff');
   END;

   PROCEDURE new_proc
   IS
   BEGIN
      DBMS_OUTPUT.put_line ('new stuff');
   END;
END;
/

CREATE OR REPLACE PROCEDURE use_deprecated AUTHID DEFINER
IS
BEGIN
   pkg.proc;
END;
/