DECLARE
  v_array JSON_ARRAY_T;
BEGIN
  -- JSON_ARRAY_T is the contents of the array...
  -- minus the KEYS...unless the array itself is
  -- and array of key values...sorry
  v_array := JSON_ARRAY_T.PARSE('[1,2,3,4,5]');
  v_array := JSON_ARRAY_T.PARSE('[{"A":"B"},{"B":"C"}]');
END;
/

DECLARE
  v_array JSON_ARRAY_T;
     PROCEDURE parse_me IS
     BEGIN
       -- works fine for array of scalars but not for array
       -- of key-value pairs
       DBMS_OUTPUT.PUT_LINE('Size ' || v_array.get_size);
       FOR counter IN 0..(v_array.get_size - 1) LOOP
         DBMS_OUTPUT.PUT_LINE(v_array.get_string(counter));
       END LOOP;
     END;
BEGIN
  v_array := JSON_ARRAY_T.PARSE('[1,2,3,4,5]');
  parse_me;
  v_array := JSON_ARRAY_T.PARSE('[{"A":"B"},{"B":"C"}]');
  parse_me;
END;
/

DECLARE
  v_array JSON_ARRAY_T;
     PROCEDURE parse_me IS
       v_elem   JSON_ELEMENT_T;
       v_object JSON_OBJECT_T;
       v_keys   JSON_KEY_LIST;
     BEGIN
       DBMS_OUTPUT.PUT_LINE('Size ' || v_array.get_size);
       -- arrays IN JSON start at zero
       FOR counter IN 0..(v_array.get_size - 1) LOOP
         -- load key:value into an element
         v_elem := v_array.get(counter);
         DBMS_OUTPUT.PUT_LINE(v_elem.to_string);
         -- cant interrogate array for keys and values; must
         -- use an object that has get_keys and get*
         v_object := JSON_OBJECT_T.PARSE(v_elem.to_string);
         v_keys   := v_object.GET_KEYS;
         DBMS_OUTPUT.PUT_LINE('Key:' || v_keys(1) || ' Value:' ||
                              v_object.GET_STRING(v_keys(1)));
       END LOOP;
     END;
BEGIN
  v_array := JSON_ARRAY_T.PARSE('[{"A":"B"},{"B":"C"}]');
  parse_me;
END;
/

DECLARE
  v_array JSON_ARRAY_T;
     PROCEDURE parse_me IS
     BEGIN
       DBMS_OUTPUT.PUT(v_array.get_size || ' ');
       FOR counter IN 0..(v_array.get_size - 1) LOOP
         DBMS_OUTPUT.PUT(v_array.get_string(counter) || ':');
       END LOOP;
       DBMS_OUTPUT.PUT_LINE('');
     END;
BEGIN

  v_array := JSON_ARRAY_T.PARSE('["A","B","C"]');
  v_array.append('D');
  parse_me;

  v_array := JSON_ARRAY_T.PARSE('["A","B","C"]');
  v_array.put(1,'BBB');
  parse_me;

  v_array := JSON_ARRAY_T.PARSE('["A","B","C"]');
  v_array.put(1,'BBB',TRUE);
  parse_me;

END;
/

DECLARE
  v_array JSON_ARRAY_T;
     PROCEDURE parse_me IS
     BEGIN
       DBMS_OUTPUT.PUT(v_array.get_size || ' ');
       FOR counter IN 0..(v_array.get_size - 1) LOOP
         DBMS_OUTPUT.PUT(v_array.get_string(counter) || ':');
       END LOOP;
       DBMS_OUTPUT.PUT_LINE('');
     END;
BEGIN

  v_array := JSON_ARRAY_T.PARSE('["A","B","C"]');
  v_array.put_null(1);
  parse_me;

  v_array := JSON_ARRAY_T.PARSE('["A","B","C"]');
  v_array.put_null(1,TRUE);
  parse_me;

END;
/
