CREATE OR REPLACE PACKAGE qz_restaurant_pkg
   AUTHID DEFINER
AS
   PROCEDURE eat_that (item_in IN VARCHAR2, make_it_spicy_in_in IN BOOLEAN);

   FUNCTION eaten (item_in IN VARCHAR2)
      RETURN BOOLEAN;
END;
/

CREATE OR REPLACE PACKAGE BODY qz_restaurant_pkg
AS
   PROCEDURE eat_that (item_in IN VARCHAR2, make_it_spicy_in_in IN BOOLEAN)
   IS
   BEGIN
      DBMS_OUTPUT.put_line (
         CASE WHEN make_it_spicy_in_in THEN 'Spicy ' END || item_in);
   END;

   FUNCTION eaten (item_in IN VARCHAR2)
      RETURN BOOLEAN
   IS
   BEGIN
      RETURN CASE WHEN item_in LIKE 's%' THEN TRUE ELSE FALSE END;
   END;
END;
/

BEGIN
   EXECUTE IMMEDIATE 'BEGIN qz_restaurant_pkg.eat_that(:i, :s); END;'
      USING 'sandwich', TRUE;
END;
/

BEGIN
   EXECUTE IMMEDIATE 'BEGIN 
      IF qz_restaurant_pkg.eaten (:i) 
      THEN 
         DBMS_OUTPUT.PUT_LINE (:i); 
      END IF; 
    END;' USING 'sandwich';
END;
/

DECLARE
   l_sandwich   VARCHAR2(100);
BEGIN
   EXECUTE IMMEDIATE 'BEGIN 
      SELECT :s INTO :d
        FROM dual
       WHERE 1 = 1;
      
      DBMS_OUTPUT.PUT_LINE (:d); 
    END;'
      USING 'sandwich', IN OUT l_sandwich;
END;
/

DECLARE
   l_sandwich   VARCHAR2(100);
BEGIN
   EXECUTE IMMEDIATE 'BEGIN 
      SELECT :s INTO :d
        FROM dual
       WHERE :b;
      
      DBMS_OUTPUT.PUT_LINE (:d); 
    END;'
      USING 'sandwich', OUT l_sandwich, qz_restaurant_pkg.eaten ('sandwich');
END;
/