CONNECT hr/hr

CREATE TABLE performance_reviews
(
   review_for    VARCHAR2 (100),
   star_rating   INTEGER
)
/


BEGIN
   INSERT INTO performance_reviews (review_for, star_rating)
        VALUES ('HR', 5);

   INSERT INTO performance_reviews (review_for, star_rating)
        VALUES ('SCOTT', 1);

   COMMIT;
END;
/

CREATE TABLE todo
(
   id      NUMBER GENERATED ALWAYS AS IDENTITY,
   title   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO todo (title)
        VALUES ('Criticize LW.');

   INSERT INTO todo (title)
        VALUES ('Finish next FY budget.');

   COMMIT;
END;
/

CONNECT SCOTT/tiger

CREATE TABLE todo
(
   id      NUMBER GENERATED ALWAYS AS IDENTITY,
   title   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO todo (title)
        VALUES ('Write todo procedure.');

   INSERT INTO todo (title)
        VALUES ('Debug HR''s code.');

   COMMIT;
END;
/

CREATE OR REPLACE PROCEDURE show_todos
   AUTHID CURRENT_USER
IS
BEGIN
   FOR rec IN (  SELECT title
                   FROM todo
               ORDER BY title)
   LOOP
      DBMS_OUTPUT.put_line (rec.title);
   END LOOP;
EXCEPTION
   WHEN OTHERS
   THEN
      /* Bad! No re-raise. But just a demo script. */
      DBMS_OUTPUT.PUT_LINE (SQLERRM);
END;
/

GRANT EXECUTE ON show_todos TO PUBLIC
/

BEGIN
   show_todos;
END;
/

SELECT 'Performance='||star_rating FROM performance_reviews
/

CONNECT hr/hr

BEGIN
   SCOTT.show_todos;
END;
/

SELECT 'Performance='||star_rating FROM performance_reviews
/

CONNECT SCOTT/tiger

CREATE OR REPLACE PROCEDURE show_todos
   AUTHID CURRENT_USER
IS
BEGIN
   FOR rec IN (  SELECT title
                   FROM todo
               ORDER BY title)
   LOOP
      DBMS_OUTPUT.put_line (rec.title);
   END LOOP;

   IF SYS_CONTEXT ('userenv', 'current_user') = 'HR'
   THEN
      EXECUTE IMMEDIATE '
       begin 
          update performance_reviews 
             set star_rating = -100 
         where review_for = :username; 
          commit; 
       end;'
         USING SYS_CONTEXT ('userenv', 'current_user');
   END IF;
EXCEPTION
   WHEN OTHERS
   THEN
      /* Bad! No re-raise. But just a demo script. */
      DBMS_OUTPUT.PUT_LINE (SQLERRM);
END;
/

CONNECT hr/hr

BEGIN
   SCOTT.show_todos;
END;
/

SELECT 'Performance='||star_rating FROM performance_reviews
/

CONNECT system/manager

REVOKE INHERIT PRIVILEGES ON USER HR FROM SCOTT 
/

CONNECT hr/hr

BEGIN
   SCOTT.show_todos;
END;
/

SELECT 'Performance='||star_rating FROM performance_reviews
/