create or replace function convert_currency_macro (
  ex_rate number, amount number
) return varchar2 sql_macro ( scalar ) is
begin

  return ' amount * ex_rate ';
  
end convert_currency_macro;
/


select convert_currency_macro ( exrate, 10 ) 
from   currency_exrates;


select exrate * 10 
from   currency_exrates;


/* Can't call in PL/SQL */
var price number;
exec :price := convert_currency_macro ( 1.2, 10 ) ;








create or replace function convert_currency_plsql (
  ex_rate number, amount number
) return number is
begin

  return amount * ex_rate;
  
end convert_currency_plsql;
/

create or replace function convert_currency_udf (
  ex_rate number, amount number
) return number is
  pragma udf;
begin

  return amount * ex_rate;
  
end convert_currency_udf;
/







declare
  procedure func_benchmark ( func varchar2 ) as
    start_time pls_integer;
    run_time   pls_integer := 0;
    total_time pls_integer := 0;
    iterations pls_integer := 7;
    converted  dbms_sql.number_table;
    
  begin
    for j in 1 .. iterations loop
      start_time := dbms_utility.get_time();
      for i in 1 .. 500 loop
        execute immediate '
        select ' || dbms_assert.sql_object_name ( func ) || ' ( 1, level ) 
        from   dual
        connect by level <= 1000'
        bulk collect
        into converted;
      end loop;
      run_time := dbms_utility.get_time() - start_time ;
      total_time := total_time + run_time;
      dbms_output.put_line ( 
        'Func ' || func || ' run #' || j || 
        ' time = ' || run_time
      );
    end loop;
    
    dbms_output.put_line ( 
      'Func ' || func || 
      ' mean time = ' || round ( total_time / iterations )
    );
    dbms_output.put_line ( 
      '/******************************************/'
    );
  end;
begin
  func_benchmark ( 'convert_currency_macro' );
  func_benchmark ( 'convert_currency_plsql' );
  func_benchmark ( 'convert_currency_udf' );
end;
/
