/* Before */

DECLARE
   indx        PLS_INTEGER;

   TYPE objects_t IS TABLE OF all_objects.object_name%TYPE
      INDEX BY PLS_INTEGER;

   l_empty     objects_t;
   l_objects   objects_t := l_empty;
BEGIN
   l_objects.delete;
   
   IF l_objects.LAST IS NOT NULL
   THEN
      DBMS_OUTPUT.put_line (l_objects.COUNT);
   END IF;

   l_objects (100) := 'BLIP';

     SELECT object_name
       BULK COLLECT INTO l_objects
       FROM all_objects
      WHERE object_name LIKE '%TABLE%'
   ORDER BY object_name;

   FOR indx IN 1 .. l_objects.COUNT
   LOOP
      DBMS_OUTPUT.put_line (l_objects (indx));
      EXIT WHEN indx = l_objects.COUNT;
   END LOOP;
END;
/

/* after */

DECLARE
   TYPE objects_t IS TABLE OF all_objects.object_name%TYPE;

   l_objects   objects_t;
BEGIN
     SELECT object_name
       BULK COLLECT INTO l_objects
       FROM all_objects
      WHERE object_name LIKE '%TABLE%'
   ORDER BY object_name;

   FOR indx IN 1 .. l_objects.COUNT
   LOOP
      DBMS_OUTPUT.put_line (l_objects (indx));
   END LOOP;
END;
/

