/* Before */

I create this table, and populate it:

CREATE TABLE plch_customers (
   custnum    INTEGER NOT NULL,
   custname   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO plch_customers VALUES (1, 'Joe');
   INSERT INTO plch_customers VALUES (100, 'Sally');
   INSERT INTO plch_customers VALUES (500, 'Pete');
   COMMIT;
END;
/

CREATE OR REPLACE PACKAGE plch_pkg
IS
   CURSOR customers_cur
   IS
        SELECT *
          FROM plch_customers
      ORDER BY custnum;
END;
/

CREATE OR REPLACE PROCEDURE plch_proc
IS
   rec   plch_pkg.customers_cur%ROWTYPE := NULL;
BEGIN
   OPEN plch_pkg.customers_cur;

   FETCH plch_pkg.customers_cur INTO rec;

   DBMS_OUTPUT.put_line (rec.custname);

   IF plch_pkg.customers_cur%ISOPEN
   THEN
      CLOSE plch_pkg.customers_cur;
   END IF;

   FOR rec IN plch_pkg.customers_cur
   LOOP
      IF rec.custnum IS NOT NULL
      THEN
         DBMS_OUTPUT.put_line (rec.custname);
      END IF;

      IF NOT plch_pkg.customers_cur%ISOPEN
      THEN
         EXIT;
      END IF;

      CONTINUE;
   END LOOP;

   IF plch_pkg.customers_cur%ISOPEN
   THEN
      CLOSE plch_pkg.customers_cur;
   END IF;
END;
/

/* after */

CREATE OR REPLACE PROCEDURE plch_proc
IS
   rec   plch_pkg.customers_cur%ROWTYPE;
BEGIN
   OPEN plch_pkg.customers_cur;

   FETCH plch_pkg.customers_cur INTO rec;

   DBMS_OUTPUT.put_line (rec.custname);

   CLOSE plch_pkg.customers_cur;

   FOR rec IN plch_pkg.customers_cur
   LOOP
      DBMS_OUTPUT.put_line (rec.custname);
   END LOOP;
END;
/
