BEGIN
   NULL;
END;
/

BEGIN
   DBMS_OUTPUT.put_line ('Hello SQL');
END;
/

DECLARE
   c_message   CONSTANT VARCHAR2 (100) := 'Hello SQL';
BEGIN
   DBMS_OUTPUT.put_line (c_message);
END;
/

DECLARE
   l_message   VARCHAR2 (100) := 'Hello SQL';
BEGIN
   l_message := 'Hello SQL';
   DBMS_OUTPUT.put_line (l_message);
EXCEPTION
   WHEN VALUE_ERROR
   THEN
      DBMS_OUTPUT.put_line ('Variable too small!');
      RAISE;
END;
/


BEGIN
   BEGIN
      DBMS_OUTPUT.put_line ('Hello SQL');
   END;
   
   BEGIN
      DBMS_OUTPUT.put_line ('Hello Mom');
   END;
END;
/

DECLARE
   l_message    VARCHAR2 (100) := 'Hello SQL';
   l_message2   VARCHAR2 (100);
BEGIN
   FOR indx IN 1 .. 5
   LOOP
      l_message := l_message || ' and ' || indx;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);

   BEGIN
      l_message2 := SUBSTR (l_message, 1, 100);
      DBMS_OUTPUT.put_line (l_message2);
   END;
END;
/

DECLARE
   l_message   VARCHAR2 (100) := 'Hello SQL';
BEGIN
   FOR indx IN 1 .. 5
   LOOP
      l_message := l_message || ' and ' || indx;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);

   DECLARE
      l_message2   VARCHAR2 (100);
   BEGIN
      l_message2 := SUBSTR (l_message, 1, 100);
      DBMS_OUTPUT.put_line (l_message2);
   END;
END;
/

DECLARE
   l_message   VARCHAR2 (100) := 'Hello SQL';
BEGIN
   FOR indx IN 1 .. 5
   LOOP
      l_message := l_message || ' and ' || indx;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);

   DECLARE
      l_message2   VARCHAR2 (10);
   BEGIN
      l_message2 := SUBSTR (l_message, 1, 100);
      DBMS_OUTPUT.put_line (l_message2);
   EXCEPTION
      WHEN VALUE_ERROR
      THEN
         /* OK, that failed, but I can continue if I want */
         DBMS_OUTPUT.put_line ('Variable too small!');
   END;

   FOR indx IN 1 .. 5
   LOOP
      l_message := indx || ' and ' || l_message;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);
END;
/

/* Using a nested procedure instead of nested block */

DECLARE
   l_message   VARCHAR2 (100) := 'Hello SQL';

   PROCEDURE with_message2
   IS
      l_message2   VARCHAR2 (10);
   BEGIN
      l_message2 := SUBSTR (l_message, 1, 100);
      DBMS_OUTPUT.put_line (l_message2);
   EXCEPTION
      WHEN VALUE_ERROR
      THEN
         /* OK, that failed, but I can continue if I want */
         DBMS_OUTPUT.put_line ('Variable too small!');
   END;
BEGIN
   FOR indx IN 1 .. 5
   LOOP
      l_message := l_message || ' and ' || indx;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);

   with_message2;


   FOR indx IN 1 .. 5
   LOOP
      l_message := indx || ' and ' || l_message;
   END LOOP;

   DBMS_OUTPUT.put_line (l_message);
END;
/