CREATE TABLE qz_stay_safe
(
   id           NUMBER,
   using_this   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO qz_stay_safe VALUES (1, 'mask');
   INSERT INTO qz_stay_safe VALUES (2, 'soap');
   INSERT INTO qz_stay_safe VALUES (3, 'distance');
   INSERT INTO qz_stay_safe VALUES (3, 'stay home');

   COMMIT;
END;
/

CREATE TABLE qz_super_heroes
(
   id              NUMBER,
   nm              VARCHAR2 (30),
   special_power   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO qz_super_heroes
        VALUES (1, 'Masked Avenger', 'mask');

   INSERT INTO qz_super_heroes
        VALUES (2, 'Magic Leaper', 'distance');

   COMMIT;
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY PLS_INTEGER;

   l_stuff   stuff_t;
BEGIN
   SELECT using_this
     BULK COLLECT INTO l_stuff
     FROM qz_stay_safe
   UNION ALL
   SELECT special_power FROM qz_super_heroes;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY PLS_INTEGER;

   l_stuff   stuff_t;
BEGIN
   SELECT using_this
     BULK COLLECT INTO l_stuff
     FROM qz_stay_safe
   UNION ALL
   SELECT special_power FROM qz_super_heroes;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY VARCHAR2 (100);

   l_stuff   stuff_t;
BEGIN
   FOR rec IN (SELECT * FROM qz_stay_safe)
   LOOP
      l_stuff (l_stuff.COUNT + 1) := rec.using_this;
   END LOOP;

   FOR rec IN (SELECT * FROM qz_super_heroes)
   LOOP
      l_stuff (l_stuff.COUNT + 1) := rec.special_power;
   END LOOP;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY VARCHAR2 (100);

   l_stuff   stuff_t;
BEGIN
   FOR rec IN (SELECT * FROM qz_stay_safe)
   LOOP
      l_stuff (l_stuff.LAST + 1) := rec.using_this;
   END LOOP;

   FOR rec IN (SELECT * FROM qz_super_heroes)
   LOOP
      l_stuff (l_stuff.LAST + 1) := rec.special_power;
   END LOOP;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY VARCHAR2 (100);

   l_stuff   stuff_t;
BEGIN
   FOR rec IN (SELECT * FROM qz_stay_safe)
   LOOP
      l_stuff (rec.using_this) := rec.using_this;
   END LOOP;

   FOR rec IN (SELECT * FROM qz_super_heroes)
   LOOP
      l_stuff (rec.special_power) := rec.nm;
   END LOOP;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/

DECLARE
   TYPE stuff_t IS TABLE OF VARCHAR2 (100)
      INDEX BY VARCHAR2 (100);

   l_stuff   stuff_t;
BEGIN
   FOR rec IN (SELECT id, using_this FROM qz_stay_safe)
   LOOP
      l_stuff (rec.using_this) := rec.using_this;
   END LOOP;

   FOR rec IN (SELECT id, UPPER (special_power) special_power 
                 FROM qz_super_heroes)
   LOOP
      l_stuff (rec.special_power) := rec.nm;
   END LOOP;

   DBMS_OUTPUT.put_line ('Count='||l_stuff.COUNT);
END;
/