CREATE TABLE qz_numbers
AS
       SELECT LEVEL n
         FROM DUAL
   CONNECT BY LEVEL < 6
/

CREATE OR REPLACE FUNCTION qz_number (n_in IN NUMBER)
   RETURN NUMBER
IS
BEGIN
   DBMS_OUTPUT.put_line ('Number! ' || n_in);
   RETURN n_in;
END;
/

BEGIN
   FOR rec IN (SELECT * FROM qz_numbers)
   LOOP
      DBMS_OUTPUT.put_line ('Number! ' || rec.n);
   END LOOP;
END;
/

BEGIN
   FOR rec IN (SELECT qz_number (n) n FROM qz_numbers)
   LOOP
      DBMS_OUTPUT.put_line ('Number! ' || rec.n);
   END LOOP;
END;
/

BEGIN
   FOR rec IN (SELECT n FROM qz_numbers)
   LOOP
      DBMS_OUTPUT.put_line ('Number! ' || qz_number (rec.n));
   END LOOP;
END;
/

DECLARE
   TYPE numbers_t IS TABLE OF NUMBER;

   l_numbers   numbers_t;
BEGIN
   SELECT qz_number (n) n
     BULK COLLECT INTO l_numbers
     FROM qz_numbers;

   FOR n IN 1 .. l_numbers.COUNT
   LOOP
      DBMS_OUTPUT.put_line ('Number! ' || l_numbers (n));
   END LOOP;
END;
/

DECLARE
   CURSOR c
   IS
      SELECT qz_number (n) FROM qz_numbers;

   n   NUMBER;
BEGIN
   OPEN c;

   LOOP
      FETCH c INTO n;

      EXIT WHEN c%NOTFOUND;
      DBMS_OUTPUT.put_line ('Number! ' || n);
   END LOOP;
END;
/