/* Set at session level */

ALTER SESSION SET plsql_warnings = 'ENABLE:ALL'
/

/* Compilation from source uses session settings */

CREATE OR REPLACE PROCEDURE aftercompile
   AUTHID DEFINER
IS
BEGIN
   NULL;
END;
/

SELECT plsql_warnings "From Session"
  FROM all_plsql_object_settings
 WHERE name = 'AFTERCOMPILE'
/

/* Alter attributes with a recompile. */

ALTER PROCEDURE aftercompile COMPILE plsql_warnings = 'ERROR:ALL'
/

SELECT plsql_warnings "From Procedure Override"
  FROM all_plsql_object_settings
 WHERE name = 'AFTERCOMPILE'
/

/* Back to session settings */

CREATE OR REPLACE PROCEDURE aftercompile
   AUTHID DEFINER
IS
BEGIN
   NULL;
END;
/

SELECT plsql_warnings "Compile From Source"
  FROM all_plsql_object_settings
 WHERE name = 'AFTERCOMPILE'
/

ALTER PROCEDURE aftercompile COMPILE plsql_warnings = 'ERROR:ALL'
/

SELECT plsql_warnings "Back to Procedure Override"
  FROM all_plsql_object_settings
 WHERE name = 'AFTERCOMPILE'
/

/* Change setting for session, but ignore with recompile */

ALTER SESSION SET plsql_warnings = 'ENABLE:ALL'
/

ALTER PROCEDURE aftercompile COMPILE REUSE SETTINGS
/

SELECT plsql_warnings "Session Change No Impact with REUSE SETTINGS"
  FROM all_plsql_object_settings
 WHERE name = 'AFTERCOMPILE'
/
