SELECT TO_CHAR (created, 'dd-mon-yyyy hh24:mi:ss'),
       TRUNC (SYSDATE - created) "Dy",
       TRUNC (MOD ( (SYSDATE - created) * 24, 24)) "Hr",
       TRUNC (MOD ( (SYSDATE - created) * 24 * 60, 60)) "Mi",
       TRUNC (MOD ( (SYSDATE - created) * 24 * 60 * 60, 60)) "Sec",
       TO_CHAR (SYSDATE, 'dd-mon-yyyy hh24:mi:ss'),
       SYSDATE - created "Tdy",
       (SYSDATE - created) * 24 "Thr",
       (SYSDATE - created) * 24 * 60 "Tmi",
       (SYSDATE - created) * 24 * 60 * 60 "Tsec"
  FROM all_users
 WHERE ROWNUM < 50
/

CREATE OR REPLACE FUNCTION datediff (p_what   IN VARCHAR2,
                                     p_d1     IN DATE,
                                     p_d2     IN DATE)
   RETURN NUMBER
/* Original Tom Kyte function, from the days before CASE and more */   
AS
   l_result   NUMBER;
BEGIN
   SELECT   (p_d2 - p_d1)
          * DECODE (UPPER (p_what),
                    'SS', 24 * 60 * 60,
                    'MI', 24 * 60,
                    'HH', 24,
                    NULL)
     INTO l_result
     FROM DUAL;

   RETURN l_result;
END;
/

CREATE OR REPLACE FUNCTION datediff (p_what   IN VARCHAR2,
                                     p_d1     IN DATE,
                                     p_d2     IN DATE)
   RETURN NUMBER
/* Updated to reflect current database and PL/SQL functionality */   
AS
BEGIN
   RETURN   (p_d2 - p_d1)
          * CASE UPPER (p_what)
               WHEN 'SS' THEN 24 * 60 * 60
               WHEN 'MI' THEN 24 * 60
               WHEN 'HH' THEN 24
               ELSE NULL
            END;
END;
/