ALTER SESSION SET plsql_warnings = 'DISABLE:7203'
/

ALTER SESSION SET plsql_optimize_level = 2
/

CREATE OR REPLACE TYPE numbers_nt IS TABLE OF NUMBER
/

CREATE OR REPLACE PROCEDURE empty_the_nt (
   numbers_io   IN OUT numbers_nt)
   AUTHID DEFINER
IS
BEGIN
   numbers_io.delete;
   
   IF numbers_io.COUNT = 0
   THEN
      raise_application_error (-20000, 'Collection emptied');
   END IF;
END;
/

DECLARE
   l_numbers   numbers_nt := numbers_nt (1);

   PROCEDURE show_numbers
   IS
   BEGIN
      DBMS_OUTPUT.put_line (
         'COUNT no parameter opt level 2 =  ' || l_numbers.COUNT);
   END;
BEGIN
   empty_the_nt (l_numbers);
EXCEPTION
   WHEN OTHERS
   THEN
      show_numbers;
END;
/

ALTER SESSION SET plsql_optimize_level = 0
/

DECLARE
   l_numbers   numbers_nt := numbers_nt (1);

   PROCEDURE show_numbers
   IS
   BEGIN
      DBMS_OUTPUT.put_line (
            'COUNT no parameter no optimization =  '
         || l_numbers.COUNT);
   END;
BEGIN
   empty_the_nt (l_numbers);
EXCEPTION
   WHEN OTHERS
   THEN
      show_numbers;
END;
/

DROP PROCEDURE empty_the_nt
/

DROP TYPE numbers_nt
/