/* Duplicate placeholders in dynamic SQL */

create or replace procedure updnumval (
   col_in    in  varchar2,
   start_in  in  date,
   end_in    in  date,
   val_in    in  number
) is
   dml_str varchar2(32767) := 
      'UPDATE employees SET '
                              || col_in
                              || ' = :val 
        WHERE hire_date BETWEEN :lodate AND :hidate 
		    AND :val IS NOT NULL';
begin
   execute immediate dml_str
      using val_in,
            start_in,
            end_in,
            val_in;
end updnumval;
/

begin
   updnumval('salary', SYSDATE, SYSDATE, 100);
   rollback;
end;
/

/* Duplicate placeholders in dynamic PL/SQL */

create or replace procedure updnumval (
   col_in    in  va rchar2,
   start_in  in  date,
   end_in    in  date,
   val_in    in  number
) is
   dml_str varchar2(32767) := 'BEGIN
          UPDATE employees SET '
                              || col_in
                              || ' = :val 
           WHERE hire_date BETWEEN :lodate AND :hidate 
		       AND :val IS NOT NULL;
       END;';
begin
   execute immediate dml_str
      using val_in,
            start_in,
            end_in;
end updnumval;
/

begin
   updnumval('salary', SYSDATE, SYSDATE, 1000);
   rollback;
end;
/