-- BEFORE
create table base_table (
   ID    number primary key,
   name  varchar2(100)
)
/

create or replace procedure bc_test is
   type numtab is
      table of number;
   primary_keys numtab;
   cursor c1 is
      select ID as icn
        from base_table;
begin
   open c1;
   fetch c1
     bulk collect into primary_keys;
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'PROVIDERS',
         pm_eval.pm_eval_providers(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'AGE',
         pm_eval.pm_eval_age(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'LITIGATION',
         pm_eval.pm_eval_litig_lowes(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'BODYPART',
         pm_eval.pm_eval_bodypart(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'CAUSE',
         pm_eval.pm_eval_cause(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'FACILITY',
         pm_eval.pm_eval_facility(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'GENDER',
         pm_eval.pm_eval_gender(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'INJURY',
         pm_eval.pm_eval_injury(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'JOBTITLE',
         pm_eval.pm_eval_jobtitle(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'JURIS STATE',
         pm_eval.pm_eval_juris(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'LOE',
         pm_eval.pm_eval_loe(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'NATURE',
         pm_eval.pm_eval_nature(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'REP DELAY',
         pm_eval.pm_eval_rep(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'CARRIERTW',
         pm_eval.pm_eval_carrier(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'ALLERGIES',
         pm_eval.pm_eval_allergies(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'ARTHRITIS',
         pm_eval.pm_eval_arthritis(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'DIABETES',
         pm_eval.pm_eval_diabetes(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'HTN',
         pm_eval.pm_eval_htn(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'OBESITY',
         pm_eval.pm_eval_obesity(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'OTHER',
         pm_eval.pm_eval_other(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'PREV INJ',
         pm_eval.pm_eval_prev_inj(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'PREV TRT',
         pm_eval.pm_eval_prev_trt(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'TRT DUR',
         pm_eval.pm_eval_trt_dur(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'TRT FLG',
         pm_eval.pm_eval_trt_flg(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'TRT FRQ',
         pm_eval.pm_eval_trt_frq(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'CLM',
         pm_eval.pm_eval_clm(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'DURATION',
         pm_eval.pm_eval_duration(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'INCURRED',
         pm_eval.pm_eval_incurred(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'IND',
         pm_eval.pm_eval_ind(primary_keys(i))
      );
   forall i in primary_keys.FIRST..primary_keys.LAST
      insert into pm_temp_eval values (
         primary_keys(i),
         'REOPEN',
         pm_eval.pm_eval_reopen(primary_keys(i))
      );
end;
/

-- AFTER

create table eval_categories (
   name          varchar2(100),
   program_name  varchar2(100)
)
/

declare
   procedure ins_one (
      NAME_IN            varchar2,
      program_suffix_in  varchar2 default null
   ) is
   begin
      insert into eval_categories (
         name,
         program_name
      ) values (
         NAME_IN,
         'pm_eval.pm_eval_' || NVL(program_suffix_in, NAME_IN)
      );
   end ins_one;
begin
   ins_one('PROVIDERS');
   ins_one('TRT FRQ', 'trt_frq');
   ins_one('REP DELAY', 'rep');
   -- etc.
end;
/

create or replace procedure bc_test 
is
   type number_aat is
      table of number index by pls_integer;
   primary_keys_expanded  number_aat;
   function_values        number_aat;
   
   type name_tab is
      table of eval_categories.name%type index by pls_integer;
   keywords               name_aat;
   
   type program_name_aat is
      table of eval_categories.program_name%type index by pls_integer;
   program_names          program_name_aat;
begin
   select name,
          program_name
     bulk collect
     into keywords,
          program_names
     from eval_categories;

   for r_key in (
      select ID primary_keys
        from base_table
   ) loop
      for kw_indx in 1..keywords.COUNT loop
         l_row                            := primary_keys_expanded.COUNT + 1;
         --
         primary_keys_expanded(l_row)     := r_key.id;
         names(l_row)                     := keywords(kw_indx);
         execute immediate 'BEGIN :outval := '
                           || program_names(i)
                           || '(:inval)); END;'
            using out function_values(l_row), in r_key.id;
      end loop;
   end loop;

   forall i in primary_keys_expanded.FIRST..primary_keys_expanded.LAST
      insert into pm_temp_eval values (
         primary_keys_expanded(i),
         keywords(i),
         function_values(i)
      );
end;
/