create or replace procedure dynplsql_test (
   n number
) is
begin
   if n > 0 then
      update employees set last_name = last_name;
      dbms_output.put_line('From Inside: ' || sql%rowcount);
   else
      raise NO_DATA_FOUND;
   end if;
end;
/

declare
   procedure showstuff is
   begin
      dbms_output.put_line('Failure: ' || sql%rowcount);
      DBMS_OUTPUT.put_line(SQLCODE);
      DBMS_OUTPUT.put_line(SQLERRM);
   end;
begin
   begin                                                         
      execute immediate 'begin BLAH.BLIP; end;';
      dbms_output.put_line('Success: ' || sql%rowcount);
   exception
      when others then
         showstuff;
   end;
   
   begin                                                          
      execute immediate 'begin dynplsql_test(-1); end;';
      dbms_output.put_line('Success: ' || sql%rowcount);
   exception
      when others then
         showstuff;
   end;
   
   begin                                                          
      execute immediate 'begin dynplsql_test(1); end;';
      dbms_output.put_line('Success: ' || sql%rowcount);
   exception
      when others then
         showstuff;
   end;
end;
/