CREATE TABLE my_employees
(
   employee_id   NUMBER,
   first_name    VARCHAR2 (100),
   last_name     VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO my_employees
        VALUES (100, 'Juna', 'Silva');

   INSERT INTO my_employees
        VALUES (100, 'Loey', 'Silva');

   INSERT INTO my_employees
        VALUES (200, 'Grandpa', 'Steven');

   COMMIT;
END;
/

CREATE OR REPLACE PROCEDURE do_stuff_with_employee (
   employee_id_in   IN my_employees.employee_id%TYPE)
   AUTHID DEFINER
IS
   CURSOR names_cur
   IS
      SELECT first_name, last_name
        FROM my_employees e
       WHERE e.employee_id = do_stuff_with_employee.employee_id_in;

   l_names            names_cur%ROWTYPE;
   l_too_many_names   names_cur%ROWTYPE;
BEGIN
   OPEN names_cur;

   FETCH names_cur INTO l_names;

   IF names_cur%NOTFOUND
   THEN
      RAISE NO_DATA_FOUND;
   END IF;

   FETCH names_cur INTO l_too_many_names;

   IF names_cur%FOUND
   THEN
      CLOSE names_cur;

      RAISE TOO_MANY_ROWS;
   ELSE
      CLOSE names_cur;
   END IF;

   /* continue processing */

   DBMS_OUTPUT.put_line (
      'Name = ' || l_names.first_name || ' ' || l_names.last_name);
END;
/

BEGIN
   do_stuff_with_employee (100);
END;
/

BEGIN
   do_stuff_with_employee (300);
END;
/

BEGIN
   do_stuff_with_employee (200);
END;
/