CREATE TABLE trees
(
   tree_id     NUMBER,
   tree_name   VARCHAR2 (100)
)
/

CREATE OR REPLACE PACKAGE tree_mgr
   AUTHID DEFINER
IS
   TYPE trees_t IS TABLE OF trees%ROWTYPE;

   PROCEDURE ins_trees (trees_in IN trees_t);
END;
/


CREATE OR REPLACE PACKAGE BODY tree_mgr
IS
   PROCEDURE ins_trees (trees_in IN trees_t)
   IS
   BEGIN
      FORALL indx IN INDICES OF trees_in
         INSERT INTO trees (tree_id, tree_name)
              VALUES (trees_in (indx).tree_id, trees_in (indx).tree_name);
   END;
END;
/

DECLARE
   l_trees   tree_mgr.trees_t := tree_mgr.trees_t ();
BEGIN
   l_trees (1).tree_id := 100;
   l_trees (1).tree_name := 'Oak';
   l_trees (100).tree_id := 101;
   l_trees (100).tree_name := 'Elm';
   tree_mgr.ins_trees (l_trees);
END;
/