CREATE TABLE temptab
(
   n   NUMBER,
   d   DATE
)
/

BEGIN
   FOR indx IN 1 .. 100
   LOOP
      INSERT INTO temptab
           VALUES (indx, TRUNC (SYSDATE, 'YYYY') + DBMS_RANDOM.VALUE (1, 365));
   END LOOP;

   COMMIT;
END;
/

CREATE OR REPLACE PACKAGE collections
IS
   TYPE rows_t IS TABLE OF temptab%ROWTYPE;

   TYPE dates_t IS TABLE OF NUMBER
      INDEX BY VARCHAR2 (100);
END;
/

DECLARE
   l_rows       collections.rows_t;
   l_dates      collections.dates_t;
   l_min_date   DATE;
BEGIN
   SELECT *
     BULK COLLECT INTO l_rows
     FROM temptab;

   FOR indx IN 1 .. l_rows.COUNT
   LOOP
      l_dates (TO_CHAR (l_rows (indx).d, 'YYYY-MM-DD')) := 0;
   END LOOP;

   DBMS_OUTPUT.put_line ('min date = ' || l_dates.FIRST);
END;
/