CREATE OR REPLACE PROCEDURE load_file (location VARCHAR2, filename VARCHAR2)
AS
   CURSOR c_data
   IS
      SELECT field1 || ';' || field2 || ';' || fieldn AS lineåç FROM my_table;

   l_file    UTL_FILE.file_type;

   l_count   PLS_INTEGER;
BEGIN
   SELECT COUNT (*) INTO l_count FROM my_table;

   v_file := UTL_FILE.fopen;
   UTL_FILE.put_line (l_file, l_count);

   FOR cur_rec IN c_data
   LOOP
      UTL_FILE.put_line (l_file, cur_rec.line);
   END LOOP;

   UTL_FILE.fclose (l_file);
END;
/

/* Ask Oracle to use approximate algorithm for COUNT */

ALTER SESSION SET approx_for_aggregation = TRUE
/

CREATE OR REPLACE PROCEDURE load_file (location VARCHAR2, filename VARCHAR2)
AS
   CURSOR c_data
   IS
      SELECT field1 || ';' || field2 || ';' || fieldn AS line FROM my_table;

   l_file    UTL_FILE.file_type;
   l_lines   DBMS_SQL.varchar2_table;

   l_count   PLS_INTEGER;
BEGIN
   OPEN c_data;

   FETCH c_data BULK COLLECT INTO l_lines;

   v_file := UTL_FILE.fopen;

   UTL_FILE.put_line (l_file, l_lines.COUNT);

   FOR indx IN 1 .. l_lines.COUNT
   LOOP
      UTL_FILE.put_line (l_file, l_lines (indx));
   END LOOP;

   UTL_FILE.fclose (l_file);
END;
/

CREATE OR REPLACE PROCEDURE load_file (location VARCHAR2, filename VARCHAR2)
AS
   CURSOR c_data
   IS
      SELECT COUNT (*) OVER () row_count,
             field1 || ';' || field2 || ';' || fieldn AS lineåç
        FROM my_table;

   l_file         UTL_FILE.file_type;

   l_first_line   BOOLEAN := TRUE;
BEGIN
   v_file := UTL_FILE.fopen;
   UTL_FILE.put_line (l_file, l_count);

   FOR cur_rec IN c_data
   LOOP
      IF l_first_line
      THEN
         UTL_FILE.put_line (l_file, cur_rec.row_count);
         l_first_line := FALSE;
      END IF;

      UTL_FILE.put_line (l_file, cur_rec.line);
   END LOOP;

   UTL_FILE.fclose (l_file);
END;
/