connect hr/hr

create table qz_tools (id number primary key, nm varchar2(100))
/

create table qz_tool_parts (id number, tool_id number references qz_tools (id), nm varchar2(100))
/

create sequence qz_id_seq
/

create trigger qz_ins_upd_tr
    before insert or update
    on qz_tools
    for each row
begin
    if inserting then
        :new.id := qz_id_seq.nextval;
        elsif updating then
        :new.nm := upper(nm);
    end if;
end;
/

begin 
insert into qz_tools (id, nm) values (1, 'Chainsaw');
insert into qz_tools (id, nm) values (2, 'Lawnmower');
insert into qz_tool_parts (id, tool_id, nm) values (1, 1, 'Chain');
insert into qz_tool_parts (id, tool_id, nm) values (2, 2, 'Blade');
commit;
end;
/

begin
update qz_tools set nm = 'Really Big Chainsaw'
where nm = 'Chainsaw';
dbms_session.sleep (10);
end;
/

connect scott/tiger



