CREATE TABLE plch_data
(
   visible_number     NUMBER,
   invisible_number   NUMBER INVISIBLE
)
/

BEGIN
   INSERT INTO plch_data (visible_number, invisible_number)
        VALUES (1, -1);

   COMMIT;
END;
/

CREATE OR REPLACE PACKAGE plch_pkg
   AUTHID DEFINER
IS
   CURSOR data_cur1
   IS
      SELECT * FROM plch_data;

   CURSOR data_cur2
   IS
      SELECT visible_number, invisible_number FROM plch_data;
END;
/

DECLARE
   rec   plch_data%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || t_rec.invisible_number);
END;
/


DECLARE
   rec   plch_pkg.data_cur1%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || t_rec.invisible_number);
END;
/

DECLARE
   rec   plch_pkg.data_cur2%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || t_rec.invisible_number);
END;
/

ALTER TABLE plch_data
   MODIFY (invisible_number VISIBLE)
/



DECLARE
   rec   plch_data%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || rec.invisible_number);
END;
/


DECLARE
   rec   plch_pkg.data_cur1%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || rec.invisible_number);
END;
/

DECLARE
   rec   plch_pkg.data_cur2%ROWTYPE;
BEGIN
   SELECT *
     INTO rec
     FROM plch_data
    WHERE ROWNUM < 2;

   DBMS_OUTPUT.PUT_LINE ('invisible = ' || rec.invisible_number);
END;
/

DROP TABLE plch_data
/

DROP PACKAGE plch_pkg
/