CREATE TABLE json_data (my_doc CLOB)
/

BEGIN
   INSERT INTO json_data
        VALUES (q'^{
          "without_spaces" : "OK",
          "with spaces not a good idea" : "Not OK",
          "carriage returns definitely bad idea" : 
      "BEGIN 
          DBMS_OUTPUT.PUT_LINE ('Hello JSON!'); 
       END;"}^');

   COMMIT;
END;
/

SELECT json_value (j.my_doc, '$.without_spaces') r
  FROM json_data j
/

SELECT json_value (j.my_doc, '$."without_spaces"') r
  FROM json_data j
/

SELECT json_value (j.my_doc, '$.with spaces not a good idea') r
  FROM json_data j
/

SELECT json_value (j.my_doc, '$."with spaces not a good idea"') r
  FROM json_data j
/

SELECT NVL (json_value (j.my_doc, '$."carriage returns definitely bad idea"'), 'Nothing') r
  FROM json_data j
/

DELETE FROM json_data
/

ALTER TABLE json_data
ADD CONSTRAINT json_data_json_chk
CHECK (my_doc IS json) enable
/

BEGIN
   INSERT INTO json_data
        VALUES (q'^{
          "without_spaces" : "OK",
          "with spaces not a good idea" : "Not OK",
          "carriage returns definitely bad idea" : 
      "BEGIN 
          DBMS_OUTPUT.PUT_LINE ('Hello JSON!'); 
       END;"}^');

   COMMIT;
END;
/

BEGIN
   INSERT INTO json_data
        VALUES (q'^{
          "without_spaces" : "OK",
          "with spaces not a good idea" : "Not OK",
          "carriage returns definitely bad idea" : 
      "BEGIN\\nDBMS_OUTPUT.PUT_LINE ('Hello JSON!');\\nEND;"}^');

   COMMIT;
END;
/

SELECT json_value (j.my_doc, '$."carriage returns definitely bad idea"') r
  FROM json_data j
/

DROP TABLE json_data
/