/* read consistency and plsql functions 

Start query
Pause in function
Update data
No change

Matter where you call it in the query? What about in an update?

Turn on/off changes?

*/

CREATE TABLE qz_rows (n NUMBER)
/

INSERT INTO qz_rows
       SELECT LEVEL
         FROM DUAL
   CONNECT BY LEVEL <= 100
/

CREATE OR REPLACE FUNCTION qz_count (delay_in in varchar2)
   RETURN INTEGER
IS
   l_count   INTEGER;
BEGIN
   SELECT COUNT (*) INTO l_count FROM qz_rows;

   if delay_in = 'Y' then DBMS_SESSION.sleep (1); end if;
   RETURN l_count;
END;
/

BEGIN
   FOR rec IN (SELECT n, qz_count ('N') c FROM qz_rows)
   LOOP
      DBMS_OUTPUT.put_line (rec.n||'-'||rec.c);
   END LOOP;
END;
/