DROP TABLE qz_mountains
/

DROP TABLE qz_record
/

CREATE TABLE qz_mountains (nm VARCHAR2 (50))
/

CREATE TABLE qz_record (text VARCHAR2 (100))
/

create or replace function qz_mountain (counter_in in integer) return varchar2
is
begin
return case counter_in when 1 then 'Denali' when 2 then 'Lhotse' when 3 then 'Aconcagua' end;
end;
/

CREATE OR REPLACE PROCEDURE qz_add_to_record (text_in IN VARCHAR2)
   AUTHID CURRENT_USER
IS
   PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
   INSERT INTO qz_record
        VALUES (text_in);

   COMMIT;
END;
/

CREATE OR REPLACE PROCEDURE qz_populate_mountains (counter_in IN INTEGER)
   AUTHID CURRENT_USER
IS
   PRAGMA AUTONOMOUS_TRANSACTION;
   l_count   INTEGER;
BEGIN
   INSERT INTO qz_mountains
        VALUES (qz_mountain (counter_in));

   IF counter_in = 0
   THEN
      COMMIT;
      RETURN;
   END IF;

   SELECT COUNT (*) INTO l_count FROM qz_mountains;
   
   if l_count > 10 then return; end if;

   qz_add_to_record (counter_in || ' - ' || l_count);

   qz_populate_mountains (counter_in - 1);
   
   COMMIT;
END;
/

BEGIN
   qz_populate_mountains (3);
END;
/

SELECT COUNT (DISTINCT text) FROM qz_record
/

SELECT text FROM qz_record
/

SELECT * FROM qz_mountains
/

delete from qz_mountains
/

delete from qz_record
/

CREATE OR REPLACE PROCEDURE qz_populate_mountains (counter_in IN INTEGER)
   AUTHID CURRENT_USER
IS
   PRAGMA AUTONOMOUS_TRANSACTION;
   l_count   INTEGER;
BEGIN
   INSERT INTO qz_mountains
        VALUES (qz_mountain (counter_in));

   SELECT COUNT (*) INTO l_count FROM qz_mountains;
   
   if l_count > 10 then return; end if;

   qz_add_to_record (counter_in || ' - ' || l_count);

   qz_populate_mountains (counter_in - 1);
   
   COMMIT;
END;
/

BEGIN
   qz_populate_mountains (3);
END;
/
