CREATE TABLE earth_parts
(
   part_id     INTEGER,
   part_name   VARCHAR2 (100)
)
/

BEGIN
   INSERT INTO earth_parts
        VALUES (100, 'Ocean');

   INSERT INTO earth_parts
        VALUES (200, 'Mountain');

   INSERT INTO earth_parts
        VALUES (300, 'Tree');

   COMMIT;
END;
/

DECLARE
   l_name1   earth_parts.part_name%TYPE;
   l_name2   earth_parts.part_name%TYPE;
BEGIN
   SELECT part_name
     INTO l_name1
     FROM earth_parts
    WHERE part_id = 200;

      UPDATE earth_parts
         SET part_name = UPPER (part_name)
       WHERE part_id = 200
   RETURNING part_name
        INTO l_name2;

   DBMS_OUTPUT.put_line (l_name1 || '-' || l_name2);
END;
/

rollback
/

DECLARE
   l_name1   earth_parts.part_name%TYPE;
   l_name2   earth_parts.part_name%TYPE;
BEGIN
   SELECT part_name
     INTO l_name1
     FROM earth_parts
    WHERE part_id = 200;

      UPDATE earth_parts ep
         SET part_name = UPPER (part_name)
       WHERE part_id = 200
   RETURNING (SELECT ep.part_name FROM DUAL), part_name
        INTO l_name1, l_name2;

   DBMS_OUTPUT.put_line (l_name1 || '-' || l_name2);
END;
/

rollback
/

DECLARE
   l_name1   earth_parts.part_name%TYPE;
   l_name2   earth_parts.part_name%TYPE;
BEGIN
      UPDATE earth_parts ep
         SET part_name = UPPER (part_name)
       WHERE part_id = 200
   RETURNING (SELECT ep2.part_name
                FROM earth_parts ep2
               WHERE part_id = 200),
               part_name             
        INTO l_name1, l_name2;

   DBMS_OUTPUT.put_line (l_name1 || '-' || l_name2);
END;
/

rollback
/

DECLARE
   l_name1   earth_parts.part_name%TYPE;
   l_name2   earth_parts.part_name%TYPE;
BEGIN
      UPDATE earth_parts
         SET part_name = UPPER (part_name)
       WHERE part_id = 200
   RETURNING part_name
        INTO l_name2;
        
   SELECT part_name
     INTO l_name1
     FROM earth_parts
    WHERE part_id = 200;

   DBMS_OUTPUT.put_line (l_name1 || '-' || l_name2);
END;
/

DROP TABLE earth_parts
/