DROP TABLE t
/

DROP PACKAGE pkg
/

CREATE TABLE t
(
   n   NUMBER,
   v   VARCHAR2 (10)
)
/

BEGIN
   INSERT INTO t
        VALUES (1, 'a');

   INSERT INTO t
        VALUES (2, 'b');

   COMMIT;
END;
/

CREATE OR REPLACE PACKAGE pkg
   AUTHID DEFINER
IS
   TYPE tt IS TABLE OF t%ROWTYPE;

   CURSOR c
   IS
      SELECT * FROM t;

   TYPE ct IS TABLE OF c%ROWTYPE;
   
   type r is record (n number, v varchar2(10));
   
   type rt is table of r;
END;
/

DECLARE
   l_t   pkg.tt;
BEGIN
   SELECT *
     BULK COLLECT INTO l_t
     FROM t;

   FOR rec IN (SELECT * FROM TABLE (l_t))
   LOOP
      DBMS_OUTPUT.put_line (rec.v);
   END LOOP;
END;
/

DECLARE
   l_t   pkg.ct;
BEGIN
   SELECT *
     BULK COLLECT INTO l_t
     FROM t;

   FOR rec IN (SELECT * FROM TABLE (l_t))
   LOOP
      DBMS_OUTPUT.put_line (rec.v);
   END LOOP;
END;
/

DECLARE
   l_t   pkg.rt;
BEGIN
   SELECT *
     BULK COLLECT INTO l_t
     FROM t;

   FOR rec IN (SELECT * FROM TABLE (l_t))
   LOOP
      DBMS_OUTPUT.put_line (rec.v);
   END LOOP;
END;
/