CREATE OR REPLACE PACKAGE qz_tracker
   AUTHID DEFINER
IS
   TYPE when_t IS TABLE OF INTEGER
      INDEX BY VARCHAR2 (100);

   dates   when_t;

   PROCEDURE add_date (date_in IN DATE);

   PROCEDURE show_count;
END;
/

CREATE OR REPLACE PACKAGE BODY qz_tracker
IS
   PROCEDURE add_date (date_in IN DATE)
   IS
   BEGIN
      dates (TO_CHAR (date_in, 'YYYY-MM-DD HH:MI:SS')) := 0;
   END;

   PROCEDURE show_count
   IS
      l_index   VARCHAR2 (100) := dates.FIRST;
   BEGIN
      DBMS_OUTPUT.put_line ('Date Count = ' || dates.COUNT);

      WHILE l_index IS NOT NULL
      LOOP
         DBMS_OUTPUT.put_line (l_index);
         l_index := dates.NEXT (l_index);
      END LOOP;

      dates.delete;
   END;
END;
/

CREATE OR REPLACE FUNCTION qz_show_date (
   date_in           IN DATE,
   call_sysdate_in   IN VARCHAR2)
   RETURN DATE
IS
   d   DATE;
BEGIN
   qz_tracker.add_date (date_in);

   IF call_sysdate_in = 'CALL_SYSDATE'
   THEN
      qz_tracker.add_date (SYSDATE);
   END IF;

   DBMS_SESSION.sleep (1);
   RETURN date_in;
END;
/

SELECT qz_show_date (SYSDATE, 'DONT_CALL_SYSDATE')
  FROM employees
 WHERE ROWNUM < 5
/

BEGIN
   qz_tracker.show_count;
END;
/

SELECT qz_show_date (SYSDATE, 'CALL_SYSDATE')
  FROM employees
 WHERE ROWNUM < 5
/

BEGIN
   qz_tracker.show_count;
END;
/