CREATE OR REPLACE PACKAGE qz_tf AUTHID DEFINER
IS
   TYPE r IS RECORD (
      n   NUMBER,
      d   DATE
   );

   TYPE t IS TABLE OF r;

   FUNCTION f RETURN t PIPELINED;
END;
/

CREATE OR REPLACE PACKAGE BODY qz_tf
IS
   FUNCTION f RETURN t PIPELINED
   IS
      rr   r := r (n => 1, d => DATE '2019-09-01');
   BEGIN
      PIPE ROW (rr);
      RETURN;
   END;
END;
/

SELECT t.n || '-' || TO_CHAR (t.d, 'YYYY-MM-DD') info
  FROM qz_tf.f () t
/

CREATE OR REPLACE TYPE qz_ot IS OBJECT (
   n NUMBER,
   d DATE
);
/

CREATE OR REPLACE TYPE qz_nt IS TABLE OF qz_ot
/

CREATE OR REPLACE PACKAGE qz_tf AUTHID DEFINER
IS
   FUNCTION f RETURN qz_nt PIPELINED;
END;
/

CREATE OR REPLACE PACKAGE BODY qz_tf
IS
   FUNCTION f RETURN qz_nt PIPELINED
   IS
   BEGIN
      PIPE ROW (qz_ot (1, DATE '2019-09-01'));
      RETURN;
   END;
END;
/

SELECT t.n || '-' || TO_CHAR (t.d, 'YYYY-MM-DD') info
  FROM qz_tf.f () t
/

CREATE OR REPLACE TYPE qz_nt IS TABLE OF qz_ot
/

CREATE OR REPLACE PACKAGE qz_tf AUTHID DEFINER
IS
   FUNCTION f RETURN qz_nt;
END;
/

CREATE OR REPLACE PACKAGE BODY qz_tf
IS
   FUNCTION f RETURN qz_nt
   IS
      t qz_nt := qz_nt (qz_ot (1, DATE '2019-09-01'));
   BEGIN
      RETURN t;
   END;
END;
/

SELECT t.n || '-' || TO_CHAR (t.d, 'YYYY-MM-DD') info
  FROM qz_tf.f () t
/

DECLARE
   l_info VARCHAR2(100);
   
   TYPE r IS RECORD (
      n   NUMBER,
      d   DATE
   );

   TYPE t IS TABLE OF r;

   FUNCTION f RETURN t PIPELINED
   IS
      rr   r := r (n => 1, d => DATE '2019-09-01');
   BEGIN
      PIPE ROW (rr);
      RETURN;
   END;
BEGIN
   SELECT t.n || '-' || TO_CHAR (t.d, 'YYYY-MM-DD') info
      INTO l_info
     FROM qz_tf.f () t;
   DBMS_OUTPUT.PUT_LINE (l_info);
END;
/


/