create or replace force editionable view "TRC"."DAILY_LICENSING_REVENUE_VW" (
   "REV_ID",
   "LICENSEE",
   "LICENSE_NO",
   "LICENSE_TYPE",
   "LICENSE_TYPE_ID",
   "NEW_FEE",
   "RENEWAL_FEE",
   "NSF",
   "VOID_UNRENEW",
   "TRACK_CODE",
   "TX_TRACK_ID",
   "REVENUE_DATE"
) as
   ( select r.id,
            last_name
            || ', '
            || first_name
            || ' '
            || middle_name as licensee,
            r.license_no,
            lt.short_desc,
            l.license_type_id,
            amount,
            null,
            null,
            null,
            r.track_code,
            r.tx_Track_id,
            trunc(revenue_date)
     from revenues r
     join licenses l
       on l.license_no = r.license_no
     join licensees le
       on l.licensee_id = le.id
     join license_types lt
       on l.license_Type_id = lt.id
    where trunc(revenue_date) > sysdate - 1000
      and r.revenue_type_code in (
             'LIC'
          )
      and r.portal in (
             'N', 'X'
          )
   union
   select r.id,
          b.description as licensee,
          r.license_no,
          lt.short_desc,
          l.license_type_id,
          amount,
          null,
          null,
          null,
          r.track_code,
          r.tx_Track_id,
          trunc(revenue_date)
     from revenues r
     join licenses l
       on l.license_no = r.license_no
     join businesses b
       on l.business_id = b.id
     join license_types lt
       on l.license_Type_id = lt.id
    where trunc(revenue_date) > sysdate - 1000
      and r.revenue_type_code in (
             'LIC', 'KENL', 'VEND', 'TRFC'
          )
      and r.portal in (
             'N', 'X'
          )
   union
   select r.id,
          last_name
          || ', '
          || first_name
          || ' '
          || middle_name as licensee,
          r.license_no,
          lt.short_desc,
          l.license_type_id,
          null,
          amount,
          null,
          null,
          r.track_code,
          r.tx_Track_id,
          trunc(revenue_date)
     from revenues r
     join licenses l
       on l.license_no = r.license_no
     join licensees le
       on l.licensee_id = le.id
     join license_types lt
       on l.license_Type_id = lt.id
    where trunc(revenue_date) > sysdate - 1000
      and r.revenue_type_code in (
             'LREN'
          )
      and r.portal in (
             'N', 'X'
          )
   union
   select r.id,
          b.description as licensee,
          r.license_no,
          lt.short_desc,
          l.license_type_id,
          null,
          amount,
          null,
          null,
          r.track_code,
          r.tx_Track_id,
          trunc(revenue_date)
     from revenues r
     join licenses l
       on l.license_no = r.license_no
     join businesses b
       on l.business_id = b.id
     join license_types lt
       on l.license_Type_id = lt.id
    where trunc(revenue_date) > sysdate - 1000
      and r.revenue_type_code in (
             'LREN', 'KREN', 'VREN', 'TFREN'
          )
      and r.portal in (
             'N', 'X'
          )
   );