create or replace view rules_combined as
   select pbs.product_line_id,
          pbs.site_id,
          ar.admin_auto_approval_rule_id,
          ar.name,
          coalesce ((select spl.value1
                     from admin_auto_approval_rule_by_site_by_product_line spl
                    where pbs.product_line_id = spl.product_line_id 
                      and pbs.site_id = spl.site_id), 
                    (select default_value1 
                     from admin_auto_approval_rule ar2
                    where ar.admin_auto_approval_rule_id = ar2.admin_auto_approval_rule_id)
          ) value1,
          coalesce ((select spl.value2
                     from admin_auto_approval_rule_by_site_by_product_line spl
                    where pbs.product_line_id = spl.product_line_id 
                      and pbs.site_id = spl.site_id), 
                    (select default_value2 
                     from admin_auto_approval_rule ar2
                    where ar.admin_auto_approval_rule_id = ar2.admin_auto_approval_rule_id)
          ) value2
     from part_by_site pbs,
          admin_auto_approval_rule ar
/

-- Values that do not exist in admin_auto_approval_rule_by_site_by_product_line

select product_line_id,
       site_id,
       admin_auto_approval_rule_id,
       name,
       value1,
       value2
  from rules_combined
 where product_line_id = 11111
   and site_id = 22222
/

-- Values that do exist in admin_auto_approval_rule_by_site_by_product_line

select product_line_id,
       site_id,
       b.admin_auto_approval_rule_id,
       b.name,
       c.value1,
       c.value2
  from rules_combined
 where product_line_id = 1
   and site_id = 2
/