create or replace package tmr is
   procedure capture;
   procedure start_timer;
   function elapsed return number;
   procedure show_elapsed (
      p_message in varchar2 default null
   );
end tmr;
/

create or replace package body tmr is
   last_timing number := null;

   procedure capture is
   begin
      last_timing := DBMS_UTILITY.GET_TIME;
   end;
   
   procedure start_timer is
   begin
      capture;
   end;

   function elapsed return number is
   begin
      return ( mod(DBMS_UTILITY.GET_TIME - last_timing + POWER(2, 32), POWER(2, 32)) );
   end;

   procedure show_elapsed (
      p_message in varchar2 default null
   ) is
   begin
      DBMS_OUTPUT.PUT_LINE(p_message);
      DBMS_OUTPUT.PUT_LINE(elapsed);
   end;
end tmr;
/

declare
   a  number;
   b  number;
   c  number;
   a1 number;
   b1 number;
   c1 number;
   n  number;
begin
   tmr.capture;
   for indx in 1..1000000 loop
      if a is null and b is null and c is null and a1 is null and b1 is null and c1 is null then
         n := 100;
      end if;
   end loop;
   dbms_output.put_line(n);
   tmr.show_elapsed;
   tmr.capture;
   for indx in 1..1000000 loop
      if coalesce(
         a,
         b,
         c,
         a1,
         b1,
         c1
      ) is null then
         n := 100;
      end if;
   end loop;
   dbms_output.put_line(n);
   tmr.show_elapsed;
end;
/